/**
 * The status of the Kobold's home.
 */
function HomeStatus() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.status = HomeStatusEnum.UNSAVED;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
    
    /**
     * Loads this object from a type-stripped version thereof.
     * @param {HomeStatus-stripped} home A HomeStatus object, stripped of private members and all functions.
     */
    this.load = function (home) {
        if(!home) {
            that.load(new HomeStatus());
            return;
        } 
        that.status = home.status;
    };
}

