/**
 * What the kobold did during the third day of Varanar.
 */
function DayThreeShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.morning = new MorningThreeShared();

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {DayThreeShared-stripped} dayThree A DayThreeShared object, stripped of private members and all functions.
     */
    this.load = function (dayThree) {
        if (!dayThree) {
            that.load(new DayThreeShared());
            return;
        }
        that.morning.load(dayThree.morning);
    };
}

