/**
 * Barn section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function BarnResist(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var rapeId = "barnTableRapeButton";
    var persuadeId = "barnTablePersuadeButton";

    var toRape = new BarnTableRape(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var shirt = ctrl.misc.shirt();
        var bra = ctrl.misc.bra();
        var dick = ctrl.misc.dick();
        var cunt = ctrl.misc.cunt();
        var cuntVirgin = ctrl.misc.cuntVirgin();
        var gender = ctrl.misc.gender();
        var toReturn = `[p]
                           No.
                           You [b]refuse[/b] to give in.
                           She may have managed to inject you, but that just means the battlefield has shifted from outside of your body, to inside of it.
                           You grit your teeth and focus your mind.
                        [/p]
                        [p]
                            You can feel your body starting to tingle, as though attempting to change, but you [b]won't[/b] let it.
                            You won't let [b]her[/b] win.
                            Losing focus for a moment, you can instantly [b]feel[/b] a few minor alterations occurring,
                            but within seconds you put your mind back to the task of resisting the potion's influence.
                            You are [b]stronger[/b] than it.
                            You can outlast it.
                            It will [b]not[/b] break you.
                            [b]She[/b] will not break you.
                        [/p]
                        [p]
                            After a solid minute of mentally hardening every fiber of your being,
                            you can feel the concoction's influence over your body slowly fading.
                            You hold your metaphorical ground for a bit longer, before dropping out of your mentally focussed state.
                            You have won, this time.
                            But you aren't sure how much more of that stuff you can weather before it'll start to alter your body, your mind or both.
                        [/p]
                        [p]
                            Your inward struggle coming to an end, you turn your attention back to your surroundings,
                            just in time to witness Cassidy emerging from the animal pen, iron chain in hand.
                            With a firm tug on the chain, she pulls a male kobold from the enclosure,
                            the spiky collar around his neck linked to the metal she holds, which acts like a leash of sorts.
                            The male is naked and visibly aroused, his member fully erect, a drop of precum already formed at the very tip.
                            His head is covered by what appears to be some kind of falconry hood, tailor-made for kobolds, blocking his sight without restricting his muzzle.
                        [/p]
                        [p]
                            The vixen closes up the cubicle once more.
                            Her [i]pet[/i] in tow, she begins to march towards you.
                            "[color=orange]Surprise.[/color]" the woman states plainly, too upset with you to so much as [i]feign[/i] enthusiasm.
                            "[color=orange]I thought I'd bring you a little [i]friend[/i].
                            Aren't you glad to see another of your kind?
                            I think he's happy to meet you too.[/color]"
                            The kobold reaches for his groin, but a cruel [b]slap[/b] makes him recoil, his hand begrudgingly returning to resting idly at his side.
                        [/p]
                        [p]
                            "[color=orange]Poor little thing hasn't had any [b]relief[/b] for [b]weeks[/b] now.
                            Given the amount of homebrewed aphrodisiac I've been administering, I doubt there's anything but [b]sex[/b] on his mind right now.
                            While wasting a pent-up load like this on a newcomer that
                            ${cunt ? "hasn't even had any fertility shots yet" : "hasn't even grown the right [i]equipment[/i] yet"}
                            might be a bit wasteful, I think I'll make an exception, [b]just for you[/b].[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildRapeChoice() {
        var disabled = ctrl.barnResist.has() ? "disabled" : "";
        var isSelected = ctrl.barnResist.get() === BarnResistChoice.RAPE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${rapeId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildPersuadeChoice() {
        var charisma = ctrl.misc.charisma();
        var likeableEnough = charisma >= 6;
        var disabled = ctrl.barnResist.has() || !likeableEnough ? "disabled" : "";
        var isSelected = ctrl.barnResist.get() === BarnResistChoice.PERSUADE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${persuadeId}" ${disabled} style="width: 200px;">Persuade</button>`;

        var tooltip;
        if (likeableEnough) {
            tooltip = global.parser.parse(`Try to talk the kobold into helping you. <span class="todo">Unavailable</span>`);
        } else {
            tooltip = global.parser.parse(`Requires [b]6 charisma[/b]. <span class="todo">Unavailable</span>`);
        }


        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildRapeChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildPersuadeChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + rapeId), $("#" + persuadeId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + rapeId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.barnResist.set(BarnResistChoice.RAPE);
            loadNextPart(toRape);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerPersuadeListener() {
        $("#" + persuadeId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.barnResist.set(BarnResistChoice.PERSUADE);
            //loadNextPart(toUnhinged);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "barnResist";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.injection.get() !== BarnInjectionChoice.RESIST) {
            return "";
        }
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.barnResist.change();
        part += buildChoice();
        part += toRape.build();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.injection.get() !== BarnInjectionChoice.RESIST) {
            return;
        }

        toRape.registerListeners();

        if (ctrl.barnResist.has()) {
            return;
        }

        registerContinueListener();
        //registerPersuadeListener();
    };
}

var BarnResistChoice = {
    RAPE: 1,
    PERSUADE: 2
};
